import * as eslint from 'eslint';
import { Block } from './processor.js';
export { parseForESLint } from './parser.js';
export { rules } from './rules/index.js';
export { C as CategoryType, f as GraphQLESLintParseResult, i as GraphQLESLintRule, g as GraphQLESLintRuleContext, G as GraphQLESLintRuleListener, b as GraphQLInvalidTestCase, c as GraphQLRuleTester, a as GraphQLValidTestCase, O as OmitRecursively, P as ParserOptions, e as ParserServices, d as Pointer, R as ReportDescriptor, h as RuleDocsInfo, S as Schema, V as ValueOf } from './types-e3367e3c.js';
export { requireGraphQLSchemaFromContext, requireSiblingsOperations } from './utils.js';
export { configs } from './configs/index.js';
export { flatConfigs } from './flat-configs.js';
import './rules/require-description.js';
import 'graphql';
import 'json-schema-to-ts/lib/types/type-utils/writable.js';
import '@graphql-tools/utils';
import 'estree';
import 'graphql-config';
import 'json-schema-to-ts';
import './estree-converter/types.js';

declare const processors: {
    graphql: eslint.Linter.Processor<string | Block>;
};

export { processors };
