"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var rules_exports = {};
__export(rules_exports, {
  rules: () => rules
});
module.exports = __toCommonJS(rules_exports);
var import_graphql_js_validation = require("./graphql-js-validation.js");
var import_alphabetize = require("./alphabetize.js");
var import_description_style = require("./description-style.js");
var import_input_name = require("./input-name.js");
var import_lone_executable_definition = require("./lone-executable-definition.js");
var import_match_document_filename = require("./match-document-filename.js");
var import_naming_convention = require("./naming-convention.js");
var import_no_anonymous_operations = require("./no-anonymous-operations.js");
var import_no_case_insensitive_enum_values_duplicates = require("./no-case-insensitive-enum-values-duplicates.js");
var import_no_deprecated = require("./no-deprecated.js");
var import_no_duplicate_fields = require("./no-duplicate-fields.js");
var import_no_hashtag_description = require("./no-hashtag-description.js");
var import_no_one_place_fragments = require("./no-one-place-fragments.js");
var import_no_root_type = require("./no-root-type.js");
var import_no_scalar_result_type_on_mutation = require("./no-scalar-result-type-on-mutation.js");
var import_no_typename_prefix = require("./no-typename-prefix.js");
var import_no_unreachable_types = require("./no-unreachable-types.js");
var import_no_unused_fields = require("./no-unused-fields.js");
var import_relay_arguments = require("./relay-arguments.js");
var import_relay_connection_types = require("./relay-connection-types.js");
var import_relay_edge_types = require("./relay-edge-types.js");
var import_relay_page_info = require("./relay-page-info.js");
var import_require_deprecation_date = require("./require-deprecation-date.js");
var import_require_deprecation_reason = require("./require-deprecation-reason.js");
var import_require_description = require("./require-description.js");
var import_require_field_of_type_query_in_mutation_result = require("./require-field-of-type-query-in-mutation-result.js");
var import_require_id_when_available = require("./require-id-when-available.js");
var import_require_import_fragment = require("./require-import-fragment.js");
var import_require_nullable_fields_with_oneof = require("./require-nullable-fields-with-oneof.js");
var import_require_nullable_result_in_root = require("./require-nullable-result-in-root.js");
var import_require_type_pattern_with_oneof = require("./require-type-pattern-with-oneof.js");
var import_selection_set_depth = require("./selection-set-depth.js");
var import_strict_id_in_types = require("./strict-id-in-types.js");
var import_unique_fragment_name = require("./unique-fragment-name.js");
var import_unique_operation_name = require("./unique-operation-name.js");
const rules = {
  ...import_graphql_js_validation.GRAPHQL_JS_VALIDATIONS,
  alphabetize: import_alphabetize.rule,
  "description-style": import_description_style.rule,
  "input-name": import_input_name.rule,
  "lone-executable-definition": import_lone_executable_definition.rule,
  "match-document-filename": import_match_document_filename.rule,
  "naming-convention": import_naming_convention.rule,
  "no-anonymous-operations": import_no_anonymous_operations.rule,
  "no-case-insensitive-enum-values-duplicates": import_no_case_insensitive_enum_values_duplicates.rule,
  "no-deprecated": import_no_deprecated.rule,
  "no-duplicate-fields": import_no_duplicate_fields.rule,
  "no-hashtag-description": import_no_hashtag_description.rule,
  "no-one-place-fragments": import_no_one_place_fragments.rule,
  "no-root-type": import_no_root_type.rule,
  "no-scalar-result-type-on-mutation": import_no_scalar_result_type_on_mutation.rule,
  "no-typename-prefix": import_no_typename_prefix.rule,
  "no-unreachable-types": import_no_unreachable_types.rule,
  "no-unused-fields": import_no_unused_fields.rule,
  "relay-arguments": import_relay_arguments.rule,
  "relay-connection-types": import_relay_connection_types.rule,
  "relay-edge-types": import_relay_edge_types.rule,
  "relay-page-info": import_relay_page_info.rule,
  "require-deprecation-date": import_require_deprecation_date.rule,
  "require-deprecation-reason": import_require_deprecation_reason.rule,
  "require-description": import_require_description.rule,
  "require-field-of-type-query-in-mutation-result": import_require_field_of_type_query_in_mutation_result.rule,
  "require-id-when-available": import_require_id_when_available.rule,
  "require-import-fragment": import_require_import_fragment.rule,
  "require-nullable-fields-with-oneof": import_require_nullable_fields_with_oneof.rule,
  "require-nullable-result-in-root": import_require_nullable_result_in_root.rule,
  "require-type-pattern-with-oneof": import_require_type_pattern_with_oneof.rule,
  "selection-set-depth": import_selection_set_depth.rule,
  "strict-id-in-types": import_strict_id_in_types.rule,
  "unique-fragment-name": import_unique_fragment_name.rule,
  "unique-operation-name": import_unique_operation_name.rule
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  rules
});
