import { FromSchema } from 'json-schema-to-ts';
import { i as GraphQLESLintRule } from '../types-e3367e3c.js';
import '@graphql-tools/utils';
import 'eslint';
import 'estree';
import 'graphql';
import 'graphql-config';
import '../estree-converter/types.js';

declare const schema: {
    readonly type: "array";
    readonly maxItems: 1;
    readonly items: {
        readonly type: "object";
        readonly additionalProperties: false;
        readonly minProperties: 1;
        readonly properties: {
            readonly withEdgeSuffix: {
                readonly type: "boolean";
                readonly default: true;
                readonly description: "Edge type name must end in \"Edge\".";
            };
            readonly shouldImplementNode: {
                readonly type: "boolean";
                readonly default: true;
                readonly description: "Edge type's field `node` must implement `Node` interface.";
            };
            readonly listTypeCanWrapOnlyEdgeType: {
                readonly type: "boolean";
                readonly default: true;
                readonly description: "A list type should only wrap an edge type.";
            };
        };
    };
};
type RuleOptions = FromSchema<typeof schema>;
declare const rule: GraphQLESLintRule<RuleOptions, true>;

export { RuleOptions, rule };
