import { FromSchema } from 'json-schema-to-ts';
import { i as GraphQLESLintRule } from '../types-2e1afd7c.js';
import '@graphql-tools/utils';
import 'eslint';
import 'estree';
import 'graphql';
import 'graphql-config';
import '../estree-converter/types.mjs';

declare const schema: {
    readonly type: "array";
    readonly maxItems: 1;
    readonly items: {
        readonly type: "object";
        readonly minProperties: 1;
        readonly additionalProperties: false;
        readonly properties: {
            readonly ignore: {
                readonly maxItems: 3;
                readonly items: {
                    readonly enum: readonly ["fragment", "query", "mutation", "subscription"];
                };
                readonly description: "Allow certain definitions to be placed alongside others.";
                readonly type: "array";
                readonly uniqueItems: true;
                readonly minItems: 1;
            };
        };
    };
};
type RuleOptions = FromSchema<typeof schema>;
declare const rule: GraphQLESLintRule<RuleOptions>;

export { RuleOptions, rule };
