import { Kind } from 'graphql';
import { i as GraphQLESLintRule } from '../types-2e1afd7c.js';
import '@graphql-tools/utils';
import 'eslint';
import 'estree';
import 'graphql-config';
import 'json-schema-to-ts';
import '../estree-converter/types.mjs';

declare const RULE_ID = "require-description";
declare const ALLOWED_KINDS: readonly [Kind.OBJECT_TYPE_DEFINITION, Kind.INTERFACE_TYPE_DEFINITION, Kind.ENUM_TYPE_DEFINITION, Kind.SCALAR_TYPE_DEFINITION, Kind.INPUT_OBJECT_TYPE_DEFINITION, Kind.UNION_TYPE_DEFINITION, Kind.DIRECTIVE_DEFINITION, Kind.FIELD_DEFINITION, Kind.INPUT_VALUE_DEFINITION, Kind.ENUM_VALUE_DEFINITION, Kind.OPERATION_DEFINITION];
type AllowedKind = (typeof ALLOWED_KINDS)[number];
type RuleOptions = [
    {
        [key in AllowedKind]?: boolean;
    } & {
        types?: boolean;
        rootField?: boolean;
    }
];
declare const rule: GraphQLESLintRule<RuleOptions>;

export { RULE_ID, RuleOptions, rule };
