import { FromSchema } from 'json-schema-to-ts';
import { i as GraphQLESLintRule } from '../types-2e1afd7c.js';
import '@graphql-tools/utils';
import 'eslint';
import 'estree';
import 'graphql';
import 'graphql-config';
import '../estree-converter/types.mjs';

declare const schema: {
    readonly definitions: {
        readonly asString: {
            readonly type: "string";
        };
        readonly asArray: {
            readonly type: "array";
            readonly uniqueItems: true;
            readonly minItems: 1;
            readonly items: {
                readonly type: "string";
            };
        };
    };
    readonly type: "array";
    readonly maxItems: 1;
    readonly items: {
        readonly type: "object";
        readonly additionalProperties: false;
        readonly properties: {
            readonly fieldName: {
                readonly oneOf: readonly [{
                    readonly $ref: "#/definitions/asString";
                }, {
                    readonly $ref: "#/definitions/asArray";
                }];
                readonly default: "id";
            };
        };
    };
};
type RuleOptions = FromSchema<typeof schema>;
declare const rule: GraphQLESLintRule<RuleOptions, true>;

export { RuleOptions, rule };
